/* $Id: clc_strendcpy.c,v 1.4 2003/03/30 13:02:39 hfuru Exp $ */
/*
 * Copyright(c) 2003, Howard Chu <hyc@highlandsun.com>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <stddef.h>
#include "clc_assert.h"
#include "clc_string.h"


char *
clc_strendcpy(char *dst, const char *CLC_RESTRICT src, const char *end)
{
	clc_assert_not_null(clc_strendcpy, dst);
	clc_assert_not_null(clc_strendcpy, src);
	clc_assert_not_null(clc_strendcpy, end);
	if (dst < end) {
		end--;		/* room for terminating NUL */
		while (dst < end && *src)
			*dst++ = *src++;
		*dst = '\0';
		if (*src)
			dst++;	/* return end parameter if truncation */
	}
	return dst;
}
