/* $Id: clc_strlcpy.c,v 1.4 2003/03/30 13:02:39 hfuru Exp $ */
/*
 * Copyright(c) 2003, Hallvard B. Furuseth <h.b.furuseth@usit.uio.no>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include "clc_assert.h"
#include "clc_string.h"

size_t
clc_strlcpy(char *CLC_RESTRICT dest, const char *CLC_RESTRICT src, size_t size)
{
	const char *start;
	clc_assert_arg(clc_strlcpy, dest != NULL && src != NULL);
	start = src;
	if (size) {
		while (--size && *src)
			*dest++ = *src++;
		*dest = '\0';
	}
	while (*src)
		++src;
	return src - start;
}

size_t
clc_strlcat(char *CLC_RESTRICT dest, const char *CLC_RESTRICT src, size_t size)
{
	size_t len;
	char *end;
	clc_assert_arg(clc_strlcat, dest != NULL && src != NULL);
	for (end = dest; *end; ++end) ;
	len = end - dest;
	return len + clc_strlcpy(end, src, size > len ? size - len : 0);
}
