/* $Id: clc_strltrim.c,v 1.6 2003/04/24 11:14:46 hfuru Exp $ */
/*
 * Copyright (c) 2003 Eric G. Miller <egm2@jps.net>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <string.h>
#include <ctype.h>
#include "clc_assert.h"
#include "clc_string.h"


/*
 * This function modifies its argument and returns a pointer to the
 * argument passed.
 *
 * Trim whitespace from the left of the string
 */
char *clc_strltrim(char *s)
{
	char *cptr, *t;

	clc_assert_not_null(clc_strltrim, s);

	cptr = s;
	while (isspace((unsigned char) *cptr)) {
		cptr++;
	}

	if (cptr != s)
		for (t = s; (*t++ = *cptr++) != '\0'; );
	return s;
}
