/* $Id: clc_strncasecmp.c,v 1.4 2003/04/25 15:07:22 hfuru Exp $ */
/*
 * Copyright(c) 2003, Hallvard B. Furuseth <h.b.furuseth@usit.uio.no>.
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <ctype.h>
#include <limits.h>
#include "clc_assert.h"
#include "clc_string.h"

int
clc_strncasecmp(const char *s1, const char *s2, size_t n)
{
	clc_assert_not_null(clc_strncasecmp, s1);
	clc_assert_not_null(clc_strncasecmp, s2);
	for (; n--; s1++, s2++) {
		unsigned char c1 = tolower((unsigned char)*s1);
		unsigned char c2 = tolower((unsigned char)*s2);
		if (c1 == '\0' || c1 != c2) {
#if UCHAR_MAX <= INT_MAX
			return c1 - c2;
#else
			return c1 < c2 ? -1 : (c1 > c2);
#endif
		}
	}
	return 0;
}
